.\" Copyright (c) 1983, 1991, 1993
.\"	The Regents of the University of California.  All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by the University of
.\"	California, Berkeley and its contributors.
.\" 4. Neither the name of the University nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.\"     @(#)insque.3	8.2 (Berkeley) 12/11/93
.\"
.Dd December 11, 1993
.Dt INSQUE 3
.Os BSD 4.2
.Sh NAME
.Nm insque ,
.Nm remque
.Nd insert/remove element from a queue
.Sh SYNOPSIS
.Bd -literal
struct qelem {
	struct	qelem *q_forw;
	struct	qelem *q_back;
	char	q_data[];
};
.Ed

.Ft void
.Fn insque "struct qelem *elem" "struct qelem *pred"
.Ft void
.Fn remque "struct qelem *elem"
.Sh DESCRIPTION
.Bf -symbolic
The insque and remque functions are considered obsolete.
.br
They are available from the compatibility library, libcompat.
.Ef
.Pp
The
.Fn insque
and 
.Fn remque
functions
manipulate queues built from doubly linked lists.  Each
element in the queue must be in the form of
.Dq Li struct qelem .
The function
.Fn insque
inserts 
.Fa elem
in a queue immediately after 
.Fa pred ;
.Fn remque
removes an entry
.Fa elem
from a queue.
.Sh SEE ALSO
.%T "VAX Architecture Handbook" ,
pp. 228-235.
.Sh HISTORY
The
.Fn insque
and
.Fn remque
functions appeared in 
.Bx 4.2 .
